image: python:3.10-slim-buster

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - when: always

stages:
  - lint
  - test
  - build
  - docker
  - post-build-test
  - publish

include:
  - template: Security/Container-Scanning.gitlab-ci.yml

variables:
  CG_IMAGE: $CI_REGISTRY_IMAGE

docker-build:
  image: docker:latest
  stage: docker
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build -t $CG_IMAGE:$CI_COMMIT_SHA -f Dockerfile .
    - docker push $CG_IMAGE:$CI_COMMIT_SHA

container_scanning:
  stage: post-build-test
  variables:
    DOCKER_IMAGE: $CG_IMAGE:$CI_COMMIT_SHA
  rules:
    - if: $CI_COMMIT_REF_PROTECTED == 'true'

registry:
  image: docker:latest
  services:
    - docker:dind
  stage: publish
  variables:
    GIT_STRATEGY: none
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker pull $CG_IMAGE:$CI_COMMIT_SHA
    - docker tag $CG_IMAGE:$CI_COMMIT_SHA $CG_IMAGE:$CI_COMMIT_REF_NAME
    - docker tag $CG_IMAGE:$CI_COMMIT_SHA $CG_IMAGE:latest
    - docker push -a $CG_IMAGE
  rules:
    - if: $CI_COMMIT_REF_PROTECTED == 'true'
